Summary: FlowScan network analysis and reporting tool
Name: FlowScan
Version: 1.006
Release: 4gls
License: GPL
Group: Development/Libraries
Source0: http://net.doit.wisc.edu/~plonka/FlowScan/%{name}-%{version}.tar.gz
Source1: flowscan.init
Patch0: FlowScan-1.006-daemon.patch
Patch1: FlowScan-1.006-destdir.patch
Patch2: FlowScan-1.006-ft.patch
BuildRoot: /var/tmp/%{name}-root
Requires: flow-tools >= 0.67
Requires: perl >= 5.6, pdksh >= 5.2.14, rrdtool >= 1.0.48, perl-Boulder, perl-ConfigReader, perl-HTML-Table, perl-Net-Patricia, perl-Cflow
BuildArch: noarch

# custom install dirs
%define installdir /usr/lib/flowscan
%define vardir %{_localstatedir}/flowscan
%define flowdir /var/ft/flows

%description
FlowScan is a network analysis and reporting tool. It processes IP flows recorded in raw flow files by e.g., cflowd, and reports on what it finds.
 
%prep 
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
./configure --prefix=%{installdir}
make

%install
rm -rf %{buildroot}
# install flowscan main program
DESTDIR=%{buildroot} make install
# install startup script
install -D -m755 %SOURCE1 %{buildroot}%{_initrddir}/flowscan
# install config files
for CF in flowscan.cf CampusIO.cf SubNetIO.cf local_nets.boulder our_subnets.boulder; do
  install -m644 cf/${CF} %{buildroot}/%{installdir}/bin
done
# install graph directory and makefile
install -d %{buildroot}/%{vardir}/graphs
install -m644 graphs.mf %{buildroot}/%{vardir}/graphs/Makefile
# install save directory
install -d %{buildroot}/%{vardir}/saved
touch %{buildroot}/%{vardir}/saved/.gzip_lock
# fix up config files
perl -i -p -e "s|FlowFileGlob flows.*|FlowFileGlob %{flowdir}/ft-v05\.*|" %{buildroot}%{installdir}/bin/flowscan.cf
perl -i -p -e "s|OutputDir graphs|OutputDir %{vardir}/graphs|" %{buildroot}%{installdir}/bin/CampusIO.cf
perl -i -p -e "s|LocalSubnetFiles bin/local_nets.boulder|LocalSubnetFiles %{installdir}/bin/local_nets.boulder|" %{buildroot}%{installdir}/bin/CampusIO.cf
perl -i -p -e "s|^Napster|#Napster|" %{buildroot}%{installdir}/bin/CampusIO.cf
perl -i -p -e "s|OutputDir graphs|OutputDir %{vardir}/graphs|" %{buildroot}%{installdir}/bin/SubNetIO.cf
perl -i -p -e "s|SubnetFiles bin/our_subnets.boulder|LocalSubnetFiles %{installdir}/bin/our_subnets.boulder|" %{buildroot}%{installdir}/bin/SubNetIO.cf
# fix up graph makefile
perl -i -p -e "s|event2vrule = /usr/lib/flowscan/bin/event2vrule|event2vrule = %{installdir}/bin/event2vrule|" %{buildroot}/%{vardir}/graphs/Makefile

%post
/sbin/chkconfig --add flowscan
/sbin/chkconfig flowscan off

%preun
if [ $1 = 0 ]; then
        %{_initrddir}/flowscan stop >/dev/null 2>&1
        /sbin/chkconfig --del flowscan
fi
exit 0

#%postun

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc COPYING INSTALL README CampusIO.README SubNetIO.README TODO Changes example util
%config(noreplace) %{installdir}/bin/*.cf
%config(noreplace) %{installdir}/bin/*.boulder
%config %{_initrddir}/flowscan
%{installdir}/*
%{vardir}/*

%changelog
* Wed Apr 27 2005 Gabriel Somlo <somlo@acns.colostate.edu>
- changed umask in init script, so graph files are readable by other applications (e.g., JKFlow)

* Tue Apr 26 2005 Gabriel Somlo <somlo@acns.colostate.edu>
- added flow-tools patch (adapted from JKFlow)

* Fri Apr 22 2005 Gabriel Somlo <somlo@acns.colostate.edu>
- removed dependency on cflowd, replaced with flow-tools

* Tue Jul 27 2004 Gabriel Somlo <somlo@acns.colostate.edu>
- Initial SRPM created
- Patches for install destdir, and daemon
- Wrote redhat/fc2 compatible init script
- Left out saving flow files in saved/ on purpose; could hack explicit save path into perl code in the future
